#include <iostream>
#include <vector>
#include <string>
#include "svg_iternal.h"

using namespace std;

void svg_text(double left, double baseline, string text) {
    cout << "<text x='" << left << "' y='" << baseline << "'>" << text << "</text>";
}

void svg_rect(double x, double y, double width, double height, string stroke, string fill) {
    cout << "<rect x='" << x << "' y='" << y << "' width='" << width << "' height='" << height << "' fill='" << fill << "' stroke='" << stroke << "' />\n";
}

void svg_begin(double width, double height) {
    cout << "<?xml version='1.0' encoding='UTF-8'?>\n";
    cout << "<svg ";
    cout << "width='" << width << "' ";
    cout << "height='" << height << "' ";
    cout << "viewBox='0 0 " << width << " " << height << "' ";
    cout << "xmlns='http://www.w3.org/2000/svg'>\n";
}

void svg_end() {
    cout << "</svg>\n";
}

string check_color(const string& color) {
    if (color.find(" ") == -1 || color.find('#') == 0) {
        return color;
    }
    else {
        return "black";
    }
}

void show_histogram_svg(const vector<size_t>& bins, const vector<string>& colors) {
    const auto IMAGE_WIDTH = 400;
    const auto IMAGE_HEIGHT = 300;
    const auto TEXT_LEFT = 20;
    const auto TEXT_BASELINE = 20;
    const auto TEXT_WIDTH = 50;
    const auto BIN_HEIGHT = 30;
    const auto BLOCK_WIDTH = 10;
    svg_begin(400, 300);
    double top = 0;
    for (size_t j = 0; j < bins.size(); j++) {
        const double bin_width = BLOCK_WIDTH * bins[j];
        svg_text(TEXT_LEFT, top + TEXT_BASELINE, to_string(bins[j]));
        svg_rect(TEXT_WIDTH, top, bin_width, BIN_HEIGHT, check_color(colors[j]), "black");
        top += BIN_HEIGHT;
    }
    svg_end();
}