#include "text.h"
#include <iostream>
#include <vector>
#include "histogram.h"

using namespace std;

void
show_histogram_text(const vector<size_t>& bins, size_t& bin_count) {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t max_count = 0;
    for (size_t i = 0; i < bin_count; i++) {
        if (bins[i] > max_count) {
            max_count = bins[i];
        }
    }
    double kof = double(MAX_ASTERISK) / max_count;
    if (kof > 1) {
        kof = 1;
    }
    for (size_t bin : bins) {
        if (bin < 100) {
            cout << " ";
        }
        if (bin < 10) {
            cout << " ";
        }
        cout << bin << "|";
        for (size_t i = 0; i < size_t(bin * kof); i++) {
            cout << "*";
        }
        cout << endl;
    }
}